import simplejson as json
import sys
import getopt
from color_utils import get_max_color,get_rank_color,get_color_rank

gauges_of_interest=[
	'Oil Check',
	'Filter Status',
	'Blower Vibration'
]

#color_ranks = {
#	"green": 1,
#	"yellow": 2,
#	"red": 3 
#}

#rank_colors = {
#	"1": "green",
#	"2": "yellow",
#	"3": "red"
#}


#def get_rank_color(rank):
#    if str(rank) not in rank_colors:
#        return "purple"
#    return rank_colors[str(rank)]

#def get_color_rank(color):
#    if color not in color_ranks:
#        return -1
#    return color_ranks[color]

machines={}

def get_machine(machineId):
    if machineId not in machines:
        machine = {
            "color": "black",
            "gauges":{}
        } 
    else:
        machine=machines[machineId]
    return machine

def gauge_alert_format_2(data):

    print("FORMAT 2: ")
    if "header" not in data:
        return machines
    
    header=data['header']
    print("Header: ",header)
    machineId = header['machineId']
    ts=header['timestamp']
    if "gauges" not in data:
        machine=get_machine(machineId)
        machine['name'] = header['machineName']
        machine['color'] = 'black'
        machines[machineId] = machine
        return machines
    gauges=data['gauges']
    max_rank=-1

    for subassembly,subassembly_values in gauges.items():
        for gauge,item in subassembly_values.items():
            print("Current gauge: ",gauge)
            machine=get_machine(machineId)
            # color = item['colors'][0]
            color = get_max_color(item['colors'])
            reason = None
            if "reason" in item:
                reason = item['reason']
            #value = ['value'][0]
            if 'kpis' in item and 'trend' in item['kpis']:
                value = item['kpis']['trend']
            else:
                value = None
            unit = None
            if 'unit' in item:
               unit = item['unit']
            rank = get_color_rank(color)
            of_interest=False
            if gauge in gauges_of_interest:
                print(f"{gauge}: {color} -- {rank}")
                of_interest = True
                if rank > max_rank:
                    max_rank = rank
            machine['gauges'][gauge] = {
                "name": gauge,
                "value": value,
                "color": color,
                "color_rank": rank,
                "of_interest": of_interest,
                "unit": unit,
                "reason": reason,
                "ts": ts
            }
    machine['name'] = header['machineName']
    machine['ts'] = ts
    print(f"max rank: {max_rank}")
    machine['color'] = get_rank_color(max_rank)
    machines[machineId] = machine
    return machines

def gauge_alert_format_1(data):

    if "header" not in data:
        return machines

    header=data['header']
    print("Header: ",header)
    machineId = header['machineId']
    ts=header['timestamp']
    if "gauge" not in data:
        machine=get_machine(machineId)
        machine['name'] = header['machineName']
        machine['color'] = 'black'
        machines[machineId] = machine
        return machines

    gauges=data['gauge']
    max_rank=-1
    for key,item in gauges.items():
        #print("key: ",key)
        #print(f"{key}: {item['color']}")
        subassembly,gauge = key.split(':')
        gauge=gauge.strip()
        #print(gauge)
        print("Current gauge: ",gauge)
        machine=get_machine(machineId)
        color = item['color'][0]
        reason = None
        if "reason" in item:
            reason = item['reason']
        #value = ['value'][0]
        if 'mart' in item and 'trend' in item['mart']:
            value = item['mart']['trend']
        elif "value" in item:
            value = item['value'][0]
        else:
            value=-1000
            print("No Trend for: ",gauge)
        unit = None
        if 'unit' in item:
           unit = item['unit']
        rank = get_color_rank(color)
        of_interest=False
        if gauge in gauges_of_interest:
            print(f"{gauge}: {color} -- {rank}")
            of_interest = True
            if rank > max_rank:
                max_rank = rank
        machine['gauges'][gauge] = {
            "name": gauge,
            "value": value,
            "color": color,
            "color_rank": rank,
            "of_interest": of_interest,
            "unit": unit,
            "reason": reason,
            "ts": ts
	}
    machine['name'] = header['machineName']
    machine['ts'] = ts
    print(f"max rank: {max_rank}")
    machine['color'] = get_rank_color(max_rank)
    machines[machineId] = machine
    return machines


def gauge_alert(data):
    if "header" not in data:
        return {}
    format = data['header'].get('output_format',1)
    if format == 1:
        return gauge_alert_format_1(data)
    else:
        return gauge_alert_format_2(data)


