import sys
import zmq
import simplejson as json
from machine_alert import gauge_alert

color_file="/tmp/machine_color.json"

port = "4447"
if len(sys.argv) > 1:
    port =  sys.argv[1]
    int(port)
    
if len(sys.argv) > 2:
    port1 =  sys.argv[2]
    int(port1)

# Socket to talk to server
context = zmq.Context()
socket = context.socket(zmq.SUB)

connect_string = f"tcp://0.0.0.0:{port}"
print("Collecting updates from %s..." % connect_string)
socket.connect ("tcp://127.0.0.1:%s" % port)
socket.subscribe("")


# Process 5 updates
total_value = 0
while True:
    print("Waiting...")
    string = socket.recv_string()
    print(f"RECV: {string}")
    print("No msg: ",len(string))
    if len(string) == 0:
        print("No msg: ",len(string))
        continue
    s=string.split("~~")
    j = json.loads(s[3])
    print(json.dumps(j,indent=4))
    print("Machine: ",s[2])
    m=gauge_alert(j)
    print(json.dumps(m,indent=4))
    with open(color_file,"w") as f:
        json.dump(m,f,indent=4)
      
